//+------------------------------------------------------------------+
//|                                            Open Candle Daily.mq4 |
//|                                                             wags |
//|                                                     www.wags.com |
//+------------------------------------------------------------------+
#property copyright "wags"
#property link      "www.wags.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#include <ChartObjects\ChartObjectsShapes.mqh>

enum SCOPE{PAST,CURR};

CChartObjectRectangle rekt_curr, rekt_past;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   if(prev_calculated == 0)
   {     
      MqlRates r[];
      ArraySetAsSeries(r,true);
      CopyRates(Symbol(),PERIOD_D1,0,90,r);    
      int bar = GetBar(); 
      rekt_curr.Create(0,"MonthDayRectangle",0,r[bar].time,r[bar].high,TimeCurrent()+1000000,r[bar].low);
      bar = GetBar(PAST);
      rekt_past.Create(0,"MonthDayRectanglePast",0,r[bar].time,r[bar].high,TimeCurrent()+1000000,r[bar].low);
      rekt_past.Color(clrBisque);
   }
   return(rates_total);
}
//+------------------------------------------------------------------+
int GetBar(SCOPE scope = CURR)
{
   MqlDateTime t;
   TimeCurrent(t);
   t.day  = 1;
   t.hour = 0;
   t.min  = 0;
   t.sec  = 0;
   if(scope == PAST)
   {
      if(t.mon -1 <= 0)
      {
         t.mon = 12;
         t.year--;
      }
      else
         t.mon--;
   }
   datetime time = StructToTime(t);
   int bar = iBarShift(Symbol(),PERIOD_D1,time,false);
   time = iTime(Symbol(),PERIOD_D1,bar);
   MqlDateTime eval;
   TimeToStruct(time,eval);
   if(!(eval.day > 7))
      return bar;
   else
      return bar - 1 >=0 ? bar -1 : 0;
   
}